/*
 This is where we define models to be used by our instance of CENode.
 Model to be incorporated into the node upon instantiation must be given here,
 each model statement must be given in the form of a string item in the array.
 */
module.exports = {
  ceModel: {
    model: [
      "conceptualise a ~ person ~ P that is a locatable thing.",
      "conceptualise a ~ cookie ~ C that is a locatable thing.",
      "conceptualise a ~ room ~ R that is a location.",
      "conceptualise an ~ object ~ O.",
      "conceptualise the person P ~ owns ~ the cookie C and has the value T as ~ temperature ~.",
      "conceptualise the cookie C ~ is attached to ~ the object O.",
      "conceptualise the cookie C ~ monitors ~ the room R.",
      "conceptualise the cookie C ~ belongs to ~ the person P and has the value T as ~ temperature ~ and has the value B as ~ battery ~ and has the value M as ~ motion ~.",
      "conceptualise the room R ~ is monitored by ~ the cookie C and has the value T as ~ temperature ~.",
      "conceptualise the object O ~ is monitored by ~ the cookie C and has the value M as ~ motion ~.",
      "there is a rule named r1 that has 'if the cookie C ~ belongs to ~ the person P then the person P ~ owns ~ the cookie C' as instruction.",
      "there is a rule named r2 that has 'if the person P ~ owns ~ the cookie C then the cookie C ~ belongs to ~ the person P' as instruction.",
      "there is a rule named r4 that has 'if the cookie C ~ belongs to ~ the person P and the cookie C ~ is in ~ the location L then the person P ~ is in ~ the location L' as instruction.",
      "there is a rule named r5 that has 'if the cookie C ~ belongs to ~ the person P and the cookie C has the value T as ~ temperature ~ then the person P has the value T as ~ temperature ~' as instruction.",
      "there is a rule named r6 that has 'if the cookie C ~ is attached to ~ the object O then the object O ~ is monitored by ~ the cookie C' as instruction.",
      "there is a rule named r7 that has 'if the object O ~ is monitored by ~ the cookie C then the cookie C ~ is attached to ~ the object O' as instruction.",
      "there is a rule named r8 that has 'if the cookie C ~ monitors ~ the room R then the room R ~ is monitored by ~ the cookie C' as instruction.",
      "there is a rule named r9 that has 'if the room R ~ is monitored by ~ the cookie C then the cookie C ~ monitors ~ the room R' as instruction.",
      "there is a rule named r10 that has 'if the cookie C ~ monitors ~ the room R and the cookie C has the value T as ~ temperature ~ then the room R has the value T as ~ temperature ~' as instruction.",
      "there is a rule named r11 that has 'if the cookie C ~ is attached to ~ the object O and the cookie C has the value M as ~ motion ~ then the object O has the value M as ~ motion ~' as instruction.",


      "there is a location named 'home'.",
      "there is a location named 'not home'.",
      "there is a cookie named 'lively fruit'.",
      "there is a cookie named 'many chocolat'.",
      "there is a cookie named 'pretty joy'."
    ]
  }
};