// API Hostname & Authorisation
const https = require('https');
const querystring = require('querystring');
const hostname = 'apis.sen.se';
const auth = 'Token d56c2eb9f2a9ef20a5bf0866b6b282df35293ed5';

var worker = function (path, callback, method, data) {
  var responseData = "";
  data = data || null;
  callback = callback || null;
  path = '/v2' + path;

  // set up http options
  var options = {
    hostname: hostname,
    port: 443,
    path: path,
    method: method,
    headers: {
      Authorization: auth
    }
  };

  // if we have POST data, add the required header to the options
  if (data) {
    data = querystring.stringify(data);
    options.headers['Content-Type'] = 'application/x-www-form-urlencoded';
    options.headers['Content-Length'] = Buffer.byteLength(data);
  }

  var request = https.request(options, function (response) {
    console.log(method + ' ' + hostname + path);

    // if we were passed a callback function,
    if (callback) {
      response.on('data', function (d) {
        // when we obtain a response, add response to responseData,
        responseData += d;
      });

      response.on('end', function () {
        // when the response is complete, pass the obtained data to callback function
        callback(response.statusCode, responseData);
      });
    }
  });

  // if we have POST data, add to the request
  if (data) request.write(data);
  request.end();
  request.on('error', function (e) {
    console.error(e);
  });
};

// expose the following functions
module.exports = {
  get: function (path, callback) {
    worker(path, callback, 'GET');
  },

  post: function (path, data, callback) {
    worker(path, callback, 'POST', data);
  },

  put: function (path, data, callback) {
    worker(path, callback, 'PUT', data);
  },

  delete: function (path, callback) {
    worker(path, callback, 'DELETE');
  }
};