const requester = require('./requestManager');

// CRUD functions for api subscriptions
// gatewayUrls must be fully qualified, i.e. http://www.example.com/update
module.exports = {
  new: function (label, gatewayUrl, subscribes) {
    // set up POST data with passed parameters
    var data = {
      label: label,
      gatewayUrl: gatewayUrl,
      subscribes: subscribes
    };

    requester.post('/subscriptions/', data, function (statusCode, response) {
      if (statusCode == '200') {
        console.log('subscription ' + (JSON.parse(response)).uid + ' created.')
      } else {
        console.log(statusCode + ': ' + response);
      }
    });
  },

  delete: function (uid) {
    requester.delete('/subscriptions/' + uid + '/', function (statusCode, response) {
      if (statusCode == '204') {
        console.log('subscription ' + uid + ' deleted.');
      } else {
        console.log(statusCode + ': ' + response);
      }
    })
  },

  update: function (uid, label, gatewayUrl, subscribes) {
    var data = {
      label: label,
      gatewayUrl: gatewayUrl,
      subscribes: subscribes
    };

    requester.put('/subscriptions/' + uid + '/', data, function (statusCode, response) {
      if (statusCode == '200') {
        console.log('subscription ' + uid + ' updated.')
      } else {
        console.log(statusCode + ': ' + response);
      }
    });
  },

  get: function (uid, callback) {
    requester.get('/subscriptions/' + uid + '/', callback);
  },

  all: function (callback) {
    requester.get('/subscriptions/', callback);
  }
};