var requester = require('./requestManager');
var moment = require('moment');
var express = require('express');
var ourNode = require('../modules/cenodeManager');
var nodes = [];

var populateNodes = function (response) {
    // recursive check to add all pages of nodes to the node array
    var parsed = JSON.parse(response);
    nodes = nodes.concat(parsed.objects);
    if (parsed.links.next != null) {
        requester.request(parsed.links.next, 'GET', populateNodes);
    } else {
        //console.log(nodes);
        console.log(nodes.length + ' nodes collected.');
        //console.log(nodes[5].publishes[0]);
        getTelemetryValue('many chocolat', 'presence');
    }
};

var getTelemetryValue = function (nodeName, feedType) {
    nodes.forEach(function (node) {
        if (node.label == nodeName) {
            node.publishes.forEach(function (feed) {
                if (feed.type == feedType) {
                    console.log('feed id for ' + feedType + ': ' + feed.uid);
                    requester.request(feed.url + 'events/', 'GET', parseTelemetry);
                }
            });
        }
    });
};

var parseTelemetry = function (response) {
    var parsed = JSON.parse(response);
    var data = parsed.objects[0].data;
    var timestamp = moment(parsed.objects[0].dateEvent).fromNow();
    //for(var propName in data) {
    //    if (data.hasOwnProperty(propName)) {
    //        var propValue = data[propName];
    //        console.log('the most recent event has data value ' + propValue + ', ' + timestamp);
    //    }
    //}
    console.log('the most recent event has data value ' + data[Object.keys(data)[0]] + ', ' + timestamp);
};

module.exports = {
    begin: function () {
        ourNode.node.agent.set_name('mother');
        console.log(ourNode.node.agent.get_name());
        ourNode.node.add_ce('conceptualise a ~ teacher ~ T that is a person.');
        requester.request('https://apis.sen.se/v2/nodes/', 'GET', populateNodes);
    }
};