const express = require('express');
const router = express.Router();
//const subscriptionManager = require('../modules/subscriptionManager');
const cenodeManager = require('../modules/cenodeManager');

/* GET home page. */
router.get('/', function (req, res) {
  res.render('index',
    {
      title: 'Conversations with Mother'
    });
});

/* POST received from API when subscription is updated. */
router.post('/subscriptions/update', function (req, res) {
  res.status(200).send(cenodeManager.parseSubscriptionEvent(req.body));
});

router.get('/converse', function (req, res) {
  res.render('converse');
});

router.get('/concepts', function (req, res) {
  res.send(cenodeManager.getConcepts());
});

router.get('/instances', function (req, res) {
  var type = req.query.type;
  var recurse = req.query.recurse;
  res.send(cenodeManager.getInstances(type, recurse));
});

router.get('/cards', function (req, res) {
  res.send(cenodeManager.getInstances('card', true));
});

router.post('/agent_name', function (req, res) {
  res.send(cenodeManager.setAgentName(req.body.name));
  console.log("Set local agent's name to " + cenodeManager.getAgentName() + ".");
});

router.post('/sentences', function (req, res) {
  res.send(cenodeManager.addSentence(req.body.sentence));
});

router.get('/reset_all', function (req, res) {
  if (req.query.auth == "74656") {
    cenodeManager.reset();
    res.redirect("/");
  } else {
    res.status(401).render('error',
      {
        message: 'Not Authorised',
        error: {
          status: 401,
          stack: "An unauthorised request was attempted."
        }
      });
  }
});

module.exports = router;
